;*********************************************************************************************
; Dateiname 	: 	SD_Move.lsp
; Autor         : 	SSM
; Erstellt      :	
; gendert    	:
;*********************************************************************************************
; Beschreibung:		- 	Bewegen von Teilen mit Positionierungsfunktionen
;					-	
;*********************************************************************************************
; nderungen
;
;*********************************************************************************************
(in-package :teo) 
(use-package :oli)

(sd-defdialog 'SD_Move


:dialog-title "Move NT"
:toolbox-button t 
   
:variables '(   
  
     ("Teil-/Baugruppenwahl")
          
       (TempBG  :value-type :part-assembly
                :modifies :instance
                :after-input
                		(progn
                		(fensterauf)

				 );progn
                :title "Teil/Bg.")
                
       (Besitzer :value-type :assembly
       		 :modifies :instance
       		 :initial-optional t
     ;  		 :initial-value "/"
       		 )         
     
       		 
     (linie1	:value-type 	:edge
     			:modifies nil    
                :title "Kreisk.beweg."
                :initial-optional T
                :after-input (sd-set-variable-status 'linie2 :optional nil )
                   
                    ) 
      
     (linie2	:value-type 	:edge
     		:modifies nil   
     		:initial-optional T
                :title "Kreisk.fest"
                 :after-input
                		(progn
                		
                		(inlinie)

				 );progn
                
                
       )              
         ("--")
          
          (next :title "umkehren"
          	:push-action (progn
                       (sd-call-cmds (position_pa TempBG
                     		:rotate
                     		:axis circen2 cirstart2
                     		:rotation_angle pi
                     		))
          
          );endprogn
                )
       
       (POSITIONING :position-part TempBG
 		  ;  :multiple-items t
 		 
       		       )


("Fenstertools")

   (fensteropen :push-action 
                      (progn
                     
                  (fensterauf)
                       ); Ende progn            
	        :title "AUF")   
	             
 (fensteloesch :push-action 
                      (progn
                      (fensterzu)
;                      (WHEN ((sd-call-cmds PRIM-VP-NAME-EXISTS "teotemp"))
                      (fensterzu)
  
                       ); Ende progn            
	        :title "ZU")


       
     
                       
     ) ;end variables
               
	:ok-action
  		'( progn 	(wechslebaugruppe) 
 					(fensterzu)
  		  );end progn

 	:cancel-action
      	'(progn (fensterzu)      
		);end Progn


  	:help-action
    	'(progn
    	(sd-display-url "C:/SD_Move.htm")
		); end progn
		

:local-functions
'(
(wechslebaugruppe ()
(sd-call-cmds (change_pa_owner :new_owner Besitzer
				:parts_assemblies TempBG
				)) 
);endewechslebaugruppe

  (inlinie()
 
  ;(display " ---- begin 1 --- ")
  (setf datis1 (sd-inq-geo-props linie1 :dest-space :global))
  ;(display (format nil "datis1 : ~a" datis1))
  
  
  (setf circen1 (sd-circle-center datis1))
  ;(display (format nil "circen1 :~a" circen1))
  
  (setf cirnor1 (sd-circle-normal datis1))
  ;(display (format nil "cirnor1 :~a" cirnor1))
   
  (setf cirstart1 (sd-circle-start-dir datis1))
  ;(display (format nil "cirstart1 :~a" cirstart1))
   
  (setf cirrad1 (sd-circle-radius datis1))
  ;(display (format nil "cirrad1 :~a" cirrad1))
  
  
  (setq flaechen1 (car (sd-call-cmds (get_selection :focus_type *sd-plane-seltype*
                                :select 
                                :by_edge_3d linie1
                                ))))
  (setq cylfl1 (car (sd-call-cmds (get_selection :focus_type *sd-cylinder-seltype*
                                :select 
                                :by_edge_3d linie1
                                ))))  
  
  (setq allfl1 (car (sd-call-cmds (get_selection :focus_type *sd-face-seltype*
                                :select 
                                :by_edge_3d linie1
                                ))))                                    
  (setq confl1 (car (sd-call-cmds (get_selection :focus_type *sd-cone-seltype*
                                :select 
                                :by_edge_3d linie1
                                )))) 
  (setq spherfl1 (car (sd-call-cmds (get_selection :focus_type *sd-sphere-seltype*
                                :select 
                                :by_edge_3d linie1
                                ))))                                                                       
                              
                              
  ;(display (format nil "flaechen1 um edge1 ~a" flaechen1)) 
  ;(display (format nil "cylfl1 um edge1 ~a" cylfl1)) 
  ;(display (format nil "allefl1 um edge1 ~a" allfl1)) 
  ;(display (format nil "confl1 um edge1 ~a" confl1))
  ;(display (format nil "spherfl1 um edge1 ~a" spherfl1))
  
  
                              
  (setf flaeinq1 (sd-inq-geo-props flaechen1 :dest-space :global))   
  ;(display (format nil "flaeinq1 ~a" flaeinq1))                            
  
                             
  (setf cylflinq1 (sd-inq-geo-props cylfl1 :dest-space :global))   
  ;(display (format nil "cylflinq1 ~a" cylflinq1))                            
  
                             
  (setf conflinq1 (sd-inq-geo-props confl1 :dest-space :global))   
  ;(display (format nil "conflinq1 ~a" conflinq1))                            
  
                            
  (setf spherflinq1 (sd-inq-geo-props spherfl1 :dest-space :global))   
  ;(display (format nil "spherflinq1 ~a" spherflinq1))                            
                              
                                
                                                    
                                
  ;(display (format nil "flaechen1 um edge1 ~a" flaechen1)) 

  
   
  (cond
    ((and flaechen1 flaechen1) (progn  
                     ;(display "in flaechen")       
                    (setf flaeinq1 (sd-inq-geo-props flaechen1 :dest-space :global))
                    (setf flnor1 (sd-plane-normal flaeinq1))  
                    );endprogn
                  )
    ((and cylfl1 cylfl1) (progn   
                  ;(display "in cylfl")
    		  (setf flnor1 (SD-CYLINDER-AXIS-DIR cylflinq1))            
    		  ;(display "nach sd-c<linderaxisdir")
                  );endprogn
                  )        
    ((and confl1 confl1) (progn   
    		;(display "confl")
    		(setf flnor1 (SD-CONE-AXIS-DIR conflinq1))            
                  );endprogn
                  )                   
    );endcond              
                  
  
 
  ;(display (format nil "flaenor1 ~a" flnor1))                             

  
  ;(display " ----  ende circ1 ----")
  ;(display "--- begin 2----")
  
  (setf datis2 (sd-inq-geo-props linie2 :dest-space :global))
  ;(display (format nil "datis2 : ~a" datis2))
  
  
  (setf circen2 (sd-circle-center datis2))
  ;(display (format nil "circen2 :~a" circen2))
  
  (setf cirnor2 (sd-circle-normal datis2))
  ;(display (format nil "cirnor2 :~a" cirnor2))
   
  (setf cirstart2 (sd-circle-start-dir datis2))
  ;(display (format nil "cirstart2 :~a" cirstart2))
   
  (setf cirrad2 (sd-circle-radius datis2))
  ;(display (format nil "cirrad2 :~a" cirrad2))
  
  
  (setq flaechen2 (sd-call-cmds (get_selection :focus_type *sd-plane-seltype*
                                :select 
                                :by_edge_3d linie2
                                )))
                                
  ;(display (format nil "flaechen2 um edge2 ~a" flaechen2)) 

  (setf fla2 (car flaechen2))  
                              
  (setf flaeinq2 (sd-inq-geo-props fla2 :dest-space :global))   
                          
  (setf flnor2 (sd-plane-normal flaeinq2))
 
  ;(display (format nil "flaenor2 ~a" flnor2))                             

 
  ;(display " -ende circ2-- ")
  
 
  
  ;Vector Radius1
  (setf PuKa1 (sd-vec-add circen1 (sd-vec-scale (sd-vec-scale cirstart1 1) cirrad1)))
  (setf VecRot1 (sd-vec-rotate cirstart1 1.5707966327 :point circen1 :direction flnor1))
  (setf PuFl1 (sd-vec-add circen1 (sd-vec-scale (sd-vec-normalize VecRot1) cirrad1)))

 
  ;Vector Radius2
  
  (setf PuKa2 (sd-vec-add circen2 (sd-vec-scale cirstart2 cirrad2)))
  (setf VecRot2 (sd-vec-rotate cirstart2 4.71238898 :point circen2 :direction flnor2))
  (setf PuFl2 (sd-vec-add circen2 (sd-vec-scale (sd-vec-normalize VecRot2) cirrad2 )))
 
 
 
  ;Punkt auf Kreis im Positiven und Negativ2
;  (setf RadPunktPos2 (sd-vec-add circen2 (sd-vec-scale (sd-vec-normalize cirstart2) cirrad2)))
;  (setf RadPunktNeg2 (sd-vec-add circen2 (sd-vec-scale (sd-vec-normalize RichEbKreisWi2) cirrad2)))

 ;(display "*************************")
  
  ;(display (format nil "VecRot1 ~a" VecRot1))
  ;(display (format nil "PuFl1 ~a " PuFl1))
  ;(display (format nil "PuKa1 ~a " PuKa1))
  ;(display (format nil "VecRot2 ~a" VecRot2))
  ;(display (format nil "PuFl2 ~a " PuFl2))
  ;(display (format nil "PuKa2 ~a " PuKa2))
  
 ;(display "*************************")
  
  (setf flnorwi (sd-vec-angle-between flnor1 flnor2))
  ;(display (format nil "FlaNormWinkel ~a" flnorwi))
  
  (setf kreuzpro (sd-vec-cross-product flnor1 flnor2))
  ;(display (format nil "Kreuzprodukt ~a" kreuzpro))
  
  

(cond 
      ((and flaechen2 flaechen2) (progn

 			(sd-call-cmds (position_pa    TempBG
 				:translate :two_ptv
  				circen1 circen2
  				))  
  			;(display (format nil "kreuzpro ~a" kreuzpro))
  			
  			
				
  			(if (not (sd-vec-null-p kreuzpro :resolution 1e-20))
  			(progn
  			
  			  ;(display "kreuprod not null")
  			  (sd-call-cmds (position_pa TempBG
                     		:rotate
                     		:axis circen2 kreuzpro
                     		:rotation_angle (+ flnorwi pi)
                     		))
  			  );endprogn
  			  );endif
			
                     	
                     	;(if (sd-vec-equal-p flnor1 flnor2)
                     	
                     	;(display "Flaechennormalen sind gleich")
                     	;);endif

#|                     	
                     	(sd-call-cmds (position_pa TempBG
                     		:rotate
                     		:axis circen2 cirstart2
                     		:rotation_angle pi
                     		))
|#                   		
			(sd-call-cmds (change_pa_owner :new_owner Besitzer
				:parts_assemblies TempBG
				)) 
		      );endprogn
	             )
	             
	             	      
		      
);endcond


  
  ;(setf produkt (* 10 par2))
  ;(display (format nil "produkt ~a" produkt))
  


  
  	 
  );end inlinie





; ---------------------------------
(fensterzu ()
  (when (sd-inq-vp-exists-p "teotemp")
                (progn
;                  (display "fenster vorhanen")
                  (sd-call-cmds (DELETE_VP "teotemp"))
                );end progn
                              );end When


);end fensterzu




;--------------------------------------------------------------------------------------
(fensterauf()

;  (display (format nil "aktuelles fenster ~a" (sd-inq-current-vp)))
;  (display (format nil "aktuelles fenster ~a" (sd-call-cmds (uic_store_vp_view (sd-inq-current-vp)))))
  (setf fensterrichtung (sd-call-cmds (uic_store_vp_view (sd-inq-current-vp))))
  
;  (setf fensterid (sd-inq-current-vp)
     
     ;          (display "viewport exitst")
               (when (sd-inq-vp-exists-p "teotemp")
                (progn
;                  (display "fenster vorhanen")
                  (sd-call-cmds (DELETE_VP "teotemp"))
                );end progn
                              );end When
;                (display "Viewport ex nicht")
             
   			 (sd-call-cmds (create_vp :name  "teotemp"
                       				:CORNER_1 850,850
                      				:corner_2 1200,1200))
 
                       	(sd-call-cmds (set_vp_drawlist "teotemp" TempBG))
              
                       	(sd-call-cmds (uic_recall_vp_view "teotemp"))
                       	(sd-call-cmds (fit_vp "teotemp"))
                       	(sd-call-cmds (update_screen)) 
 
);end fensterauf


; **********************************************************************************

 (macheAE()
         
         (sd-call-cmds (delete_3d "/3DRahmenflaeche"))
 	 (sd-call-cmds (create_workplane :new :par_face  :face testfl :name "3DRahmenflaeche"))
 	 (sd-call-cmds (geometry_mode :construction))
  	 (sd-call-cmds (project testfl))
  	 
  	 (sd-call-cmds (position_wp :workplane "/3DRahmenflaeche" :translate :dir :face_normal testfl :len abstand)) 

  	 
  	 
  );end macheae
  
; **********************************************************************************

(BGerstellen ()

(sd-call-cmds (create_assembly :name NeueBG :owner NeuBesitz))

);ende Baugruppe erstellen

  
; **********************************************************************************


(Teilex ()
;(display "Protokoll")
;(display (format nil "PARTS ist vom typ ~a" (type-of Parts)))
;(display "Parts Variable")
;(display Parts)
;(display "end Parts")


 (defun jb-inq-obj-tree-list (obj)
   (cons obj
   (apply #'nconc (mapcar #'jb-inq-obj-tree-list (sd-inq-obj-children obj)))))


#|
     (when
      ASSY
      (setf PARTS (jb-inq-obj-tree-list ASSY)) 
      (setf PARTS
	    (remove-if
	     #'(lambda (obj)
		       (not (equal (sel_item-type obj) *sd-part-seltype*))
		       );end lambda 
	     PARTS))
       );end when
|#	     
     (let
      ((n (length PARTS))
       (i 0))
      (dolist
       (part PARTS)
       (progn
;       (sd-call-cmds
;	(set_part_color (list PART) :hsl (gpnt3d (/ i n) 1 1) :done))
;	(sd-call-cmds (position_pa (list PART):translate :dir :y :len 50.0 :len 50.0 :done ))
        (sd-call-cmds (create_multiple_pa  :share :source (list PART) :OWNER Assy ))
	);end progn
       (incf i))
       );end let
       
  :mutual-exclusion '(PARTS ASSY)
 
; (sd-call-cmds (delete_3d "/3DRahemflaeche"))
 
  
;  (display (sd-call-cmds (get_selection :focus_type *sd-part-seltype*
;                                        :select :BY_FACE flae
;                                )))
;(setq doil    (sd-call-cmds (get_selection :focus_type *sd-part-seltype*
;                                :select
;                                :part
;                                :in_assembly ass
;                                ))
;)

;(delete_3d (select        :by_face flae
;                                ))

;(setq doil    (sd-call-cmds (get_selection :focus_type *sd-part-seltype*
;                                :select
;                                :BY_VERTEX_3D 
                               
;                                ))
;)







;(setq doil (sd-call-cmds (get_selection :focus_type *sd-geom-3d-seltype* :select :current )))
; (display select :edge_3d :current)
;(setq doil (select :add :part :By_Face flae :select_done))
;(display (format nil "Flaechenselitem ~a" flae))
;(display (format nil "doilseltype ~a" doil))
;(display (format nil "type of car schnittpktt ~a" (type-of (car schnittpkt))))

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
);endTeilex


);endlocalfunction 

   

 
) ;enddefdialog

; ----------------------------- T e o A t t r i BG ---------------------------
